## gtk3-nocsd 2

=== Makefile ===
PKG_CONFIG ?= pkg-config
CFLAGS ?= -O2 -g
override CFLAGS += $(shell ${PKG_CONFIG} --cflags gtk+-3.0) $(shell ${PKG_CONFIG} --cflags gobject-introspection-1.0) -pthread -Wall
LDLIBS = -ldl
CFLAGS_LIB = $(filter-out -fPIE -fpie -pie,$(CFLAGS)) -fPIC
LDFLAGS_LIB = $(filter-out -fPIE -fpie -pie,$(LDFLAGS)) -fPIC

prefix ?= /usr/local
libdir ?= $(prefix)/lib
bindir ?= $(prefix)/bin
mandir ?= $(prefix)/share/man

all: libgtk3-nocsd.so.0 gtk3-nocsd

clean:
	rm -f libgtk3-nocsd.so.0 *.o gtk3-nocsd test-static-tls *~
	[ ! -d testlibs ] || rm -r testlibs

libgtk3-nocsd.so.0: gtk3-nocsd.o
	$(CC) -shared $(CFLAGS_LIB) $(LDFLAGS_LIB) -Wl,-soname,libgtk3-nocsd.so.0 -o $@ $^ $(LDLIBS)

gtk3-nocsd.o: gtk3-nocsd.c
	$(CC) $(CPPFLAGS) $(CFLAGS_LIB) -o $@ -c $<

gtk3-nocsd: gtk3-nocsd.in
	sed 's|@@libdir@@|$(libdir)|g' < $< > $@
	chmod +x $@

install:
	install -D -m 0644 libgtk3-nocsd.so.0 $(DESTDIR)$(libdir)/libgtk3-nocsd.so.0
	install -D -m 0755 gtk3-nocsd $(DESTDIR)$(bindir)/gtk3-nocsd
	install -D -m 0644 gtk3-nocsd.1 $(DESTDIR)$(mandir)/man1/gtk3-nocsd.1

check: libgtk3-nocsd.so.0 testlibs/stamp test-static-tls
	@echo "RUNNING: test-static-tls"
	@[ "$$(LD_PRELOAD= ./test-static-tls none)" = "$$(LD_PRELOAD=./libgtk3-nocsd.so.0 ./test-static-tls gtk3-nocsd)" ] || \
		{ echo "   Without any library preloaded: can dlopen() up to the following number of libraries with static TLS:" ; \
		  echo -n "   " ; LD_PRELOAD= ./test-static-tls none ; \
		  echo "   With libgtk3-nocsd preloaded, can dlopen() up to the following number of libraries with static TLS:"; \
		  echo -n "   " ; LD_PRELOAD=./libgtk3-nocsd.so.0 ./test-static-tls gtk3-nocsd ; \
		  echo "   These should match, but they don't." ; \
		  exit 1; \
		}

testlibs/stamp: test-dummylib.c
	@# Build a lot of dummy libraries. test-static-tls tries to load all
	@# of these libraries with dlopen(), which will fail at some point
	@# (because the DTV overflow entries are used up). Build a lot of
	@# them so even if the current default changes the cutoff point can
	@# be determined.
	mkdir -p testlibs
	for i in A B C D E F G H I J K L M N O P Q R S T U V W X Y Z \
	         a b c d e f g h i j k l m n o p q r s t u v w x y z \
	         0 1 2 3 4 5 6 7 8 9 ; do \
	  $(CC) $(CPPFLAGS) $(CFLAGS_LIB) -ftls-model=initial-exec -DTESTLIB_NAME=$$i -c -o testlibs/libdummy-$$i.o test-dummylib.c ; \
	  $(CC) -shared $(CFLAGS_LIB) $(LDFLAGS_LIB) -Wl,-soname,libdummy-$$i.so.0 -o testlibs/libdummy-$$i.so.0 testlibs/libdummy-$$i.o $(LDLIBS) ; \
	done
	touch testlibs/stamp

test-static-tls: test-static-tls.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o test-static-tls test-static-tls.o $(LDLIBS)

## gtk3-nocsd 3

=== Makefile ===
--- 
+++ 
@@ -5,15 +5,17 @@
 CFLAGS_LIB = $(filter-out -fPIE -fpie -pie,$(CFLAGS)) -fPIC
 LDFLAGS_LIB = $(filter-out -fPIE -fpie -pie,$(LDFLAGS)) -fPIC
 
-prefix ?= /usr/local
-libdir ?= $(prefix)/lib
-bindir ?= $(prefix)/bin
-mandir ?= $(prefix)/share/man
+prefix            ?= /usr/local
+libdir            ?= $(prefix)/lib
+bindir            ?= $(prefix)/bin
+datadir           ?= ${prefix}/share
+mandir            ?= $(datadir)/man
+bashcompletiondir ?= ${datadir}/bash-completion/completions
 
 all: libgtk3-nocsd.so.0 gtk3-nocsd
 
 clean:
-	rm -f libgtk3-nocsd.so.0 *.o gtk3-nocsd test-static-tls *~
+	rm -f libgtk3-nocsd.so.0 *.o gtk3-nocsd test-static-tls test-now *~
 	[ ! -d testlibs ] || rm -r testlibs
 
 libgtk3-nocsd.so.0: gtk3-nocsd.o
@@ -30,8 +32,14 @@
 	install -D -m 0644 libgtk3-nocsd.so.0 $(DESTDIR)$(libdir)/libgtk3-nocsd.so.0
 	install -D -m 0755 gtk3-nocsd $(DESTDIR)$(bindir)/gtk3-nocsd
 	install -D -m 0644 gtk3-nocsd.1 $(DESTDIR)$(mandir)/man1/gtk3-nocsd.1
+	install -D -m 0644 gtk3-nocsd.bash-completion $(DESTDIR)$(bashcompletiondir)/gtk3-nocsd
 
-check: libgtk3-nocsd.so.0 testlibs/stamp test-static-tls
+check: libgtk3-nocsd.so.0 testlibs/stamp test-static-tls test-now
+	@echo "RUNNING: test-symbols"
+	@# Force LD_BIND_NOW to make sure we don't accidentally import
+	@# any symbols from glib/gdk/gtk directly. (This ensures
+	@# compatibility with software that is linked with -Wl,-z,now.)
+	@LD_PRELOAD=./libgtk3-nocsd.so.0 LD_BIND_NOW=1 ./test-now
 	@echo "RUNNING: test-static-tls"
 	@[ "$$(LD_PRELOAD= ./test-static-tls none)" = "$$(LD_PRELOAD=./libgtk3-nocsd.so.0 ./test-static-tls gtk3-nocsd)" ] || \
 		{ echo "   Without any library preloaded: can dlopen() up to the following number of libraries with static TLS:" ; \
@@ -59,3 +67,6 @@
 
 test-static-tls: test-static-tls.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o test-static-tls test-static-tls.o $(LDLIBS)
+
+test-now: test-now.o
+	$(CC) $(CFLAGS) $(LDFLAGS) -o test-now test-now.o $(LDLIBS)

=== debian/changelog ===
gtk3-nocsd (3-2) unstable; urgency=medium

  * Team upload of Debian team

  [ Christian Seiler ]
  * Xsession.d/01gtk3-nocsd: clarify comments about configuration
    Closes: #825989
  * Only cache gtk version check result if Gtk is loaded
    Closes: #886263

  [ Jelmer Vernooĳ ]
  * Migrate repository from alioth to salsa.
    Closes: #1081071

  [ Khurshid Alam ]
  * Improve the session detection fixing broken headerbars and decorations
    (patch applied directly in debian/extra instead by quilt)
    Closes: #888306 (LP: #1745206)

  [ Andreas Tille ]
  * Fix watch file
  * Build-Depends: s/markdown/discount/
    Closes: #1073094
  * Standards-Version: 4.7.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Secure URI in copyright format (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Fix lintian overrides
  * libgtk3-nocsd0 should be Section: libs

 -- Andreas Tille <tille@debian.org>  Sat, 14 Sep 2024 16:11:08 +0200

gtk3-nocsd (3-1) unstable; urgency=medium

  * Imported new upstream version 3.
      - Add bash completion support. (Closes: #824615)
      - Also override GtkDialog's GtkBuildable->add_child.
        (Closes: #824614)
      - Don't use compositor trick in Gtk+3 3.16.1 or higher.
        (Closes: #824616)
      - Don't remove menu titlebar decoration. (Closes: #824758)
      - Cosmetic improvements to the headerbar. (Closes: #824617)
  * debian/libgtk3-noscd0.symbols: add symbols from new upstream version.
  * README.Debian: add instructions for the Multi-Arch case.
  * Ship /etc/X11/Xsession.d/01gtk3-nocsd by default. (Closes: #824620)
  * debian/control: Bump Standards-Version to 3.9.8. (No changes.)
  * Xsession scripts: properly handle package removal without purge.
  * Process README.md with markdown to create nice HTML file.

 -- Christian Seiler <christian@iwakd.de>  Tue, 31 May 2016 21:21:22 +0200

gtk3-nocsd (2-1) unstable; urgency=low

  * Initial release. (Closes: #788076)

 -- Christian Seiler <christian@iwakd.de>  Sat, 19 Mar 2016 13:47:08 +0100

=== debian/control ===
Source: gtk3-nocsd
Maintainer: Christian Seiler <christian@iwakd.de>
Section: x11
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libgirepository1.0-dev,
               libglib2.0-dev,
               libgtk-3-dev,
               discount
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/gtk3-nocsd
Vcs-Git: https://salsa.debian.org/debian/gtk3-nocsd.git
Homepage: https://github.com/PCMan/gtk3-nocsd
Rules-Requires-Root: no

Package: gtk3-nocsd
Architecture: all
Depends: libgtk3-nocsd0,
         ${misc:Depends}
Description: Disable Gtk+ 3 client side decorations (CSD)
 gtk3-nocsd LD_PRELOADs a small library to disable the client side
 decorations (CSD) of Gtk+ 3.
 .
 Since Gtk+ 3.10, its developers added a so-called header bar or custom
 title bar. With this and the client-side decoration, the original
 title bar and window border provided by the window manager are
 disabled by Gtk+. This makes all Gtk+ 3 programs look like alike, but
 have different handling from other windows on non-GNOME desktops. Even
 worse, this may break some window manager or compositors.
 .
 Unfortunately, there is no reliable way of turning off CSDs in Gtk+
 directly. This library makes this possible.

Package: libgtk3-nocsd0
Architecture: any
Section: libs
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Library to disable Gtk+ 3 client side decorations (CSD)
 libgtk3-nocsd is a small LD_PRELOADable library used to disable the
 client side decorations (CSD) of Gtk+ 3.
 .
 Since Gtk+ 3.10, its developers added a so-called header bar or custom
 title bar. With this and the client-side decoration, the original
 title bar and window border provided by the window manager are
 disabled by Gtk+. This makes all Gtk+ 3 programs look like alike, but
 have different handling from other windows on non-GNOME desktops. Even
 worse, this may break some window manager or compositors.
 .
 Unfortunately, there is no reliable way of turning off CSDs in Gtk+
 directly. This library makes this possible.

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
   https://github.com/PCMan/gtk3-nocsd/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## gtk3-nocsd 3.0.7%2Bgit20210623

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,6 @@
 PKG_CONFIG ?= pkg-config
 CFLAGS ?= -O2 -g
-override CFLAGS += $(shell ${PKG_CONFIG} --cflags gtk+-3.0) $(shell ${PKG_CONFIG} --cflags gobject-introspection-1.0) -pthread -Wall
-LDLIBS = -ldl
+override CFLAGS += $(shell ${PKG_CONFIG} --cflags gtk+-3.0) $(shell ${PKG_CONFIG} --cflags gobject-introspection-1.0) -pthread -Wall -Wextra -Wno-unused-parameter
 CFLAGS_LIB = $(filter-out -fPIE -fpie -pie,$(CFLAGS)) -fPIC
 LDFLAGS_LIB = $(filter-out -fPIE -fpie -pie,$(LDFLAGS)) -fPIC
 
@@ -19,7 +18,7 @@
 	[ ! -d testlibs ] || rm -r testlibs
 
 libgtk3-nocsd.so.0: gtk3-nocsd.o
-	$(CC) -shared $(CFLAGS_LIB) $(LDFLAGS_LIB) -Wl,-soname,libgtk3-nocsd.so.0 -o $@ $^ $(LDLIBS)
+	$(CC) -ldl -shared $(CFLAGS_LIB) $(LDFLAGS_LIB) -Wl,-soname,libgtk3-nocsd.so.0 -o $@ $^ $(LDLIBS)
 
 gtk3-nocsd.o: gtk3-nocsd.c
 	$(CC) $(CPPFLAGS) $(CFLAGS_LIB) -o $@ -c $<
@@ -66,7 +65,7 @@
 	touch testlibs/stamp
 
 test-static-tls: test-static-tls.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o test-static-tls test-static-tls.o $(LDLIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o test-static-tls test-static-tls.o -ldl
 
 test-now: test-now.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o test-now test-now.o $(LDLIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o test-now test-now.o -ldl

=== debian/changelog ===
gtk3-nocsd (3.0.7+git20210623-1) mx; urgency=medium

  * New release from ZaWertun fork of abandoned PCMan code

 -- Timothy E. Harris <maintainer@mxrepo.com>  Sun, 01 Aug 2021 11:38:39 -0400

=== debian/control ===
--- 
+++ 
@@ -1,22 +1,19 @@
 Source: gtk3-nocsd
-Maintainer: Christian Seiler <christian@iwakd.de>
 Section: x11
-Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Priority: extra
+Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
+XSBC-Original-Maintainer: Christian Seiler <christian@iwakd.de>
+Build-Depends: debhelper (>= 9),
                libgirepository1.0-dev,
                libglib2.0-dev,
                libgtk-3-dev,
-               discount
-Standards-Version: 4.7.0
-Vcs-Browser: https://salsa.debian.org/debian/gtk3-nocsd
-Vcs-Git: https://salsa.debian.org/debian/gtk3-nocsd.git
-Homepage: https://github.com/PCMan/gtk3-nocsd
-Rules-Requires-Root: no
+               markdown
+Standards-Version: 3.9.8
+Homepage: https://github.com/ZaWertun/gtk3-nocsd
 
 Package: gtk3-nocsd
 Architecture: all
-Depends: libgtk3-nocsd0,
-         ${misc:Depends}
+Depends: libgtk3-nocsd0, ${misc:Depends}
 Description: Disable Gtk+ 3 client side decorations (CSD)
  gtk3-nocsd LD_PRELOADs a small library to disable the client side
  decorations (CSD) of Gtk+ 3.
@@ -32,11 +29,9 @@
  directly. This library makes this possible.
 
 Package: libgtk3-nocsd0
+Multi-Arch: same
+Depends: ${misc:Depends}, ${shlibs:Depends}
 Architecture: any
-Section: libs
-Multi-Arch: same
-Depends: ${misc:Depends},
-         ${shlibs:Depends}
 Description: Library to disable Gtk+ 3 client side decorations (CSD)
  libgtk3-nocsd is a small LD_PRELOADable library used to disable the
  client side decorations (CSD) of Gtk+ 3.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	@# Use /usr/lib here, because libdir will be used for
	@# generating the wrapper script, and we want that to be the
	@# same on all architectures. Since the script leaves it to the
	@# dynamic linker to find the library, the path is not actually
	@# used if the library is installed to a system location.
	dh_auto_build -- prefix=/usr libdir=/usr/lib

	@# Generate HTML documentation
	printf '<!DOCTYPE html><html><head><title>gtk3-nocsd README</title></head><body>\n' > README.html
	markdown README.md >> README.html
	printf '</body></html>\n' >> README.html

override_dh_auto_clean:
	dh_auto_clean
	rm -f README.html

override_dh_auto_install:
	dh_auto_install -- prefix=/usr libdir=/usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

override_dh_fixperms:
	dh_fixperms
	! [ -f debian/libgtk3-nocsd0/usr/lib/*/libgtk3-nocsd.so.0 ] || \
		chmod 4644 debian/libgtk3-nocsd0/usr/lib/*/libgtk3-nocsd.so.0

override_dh_auto_test:

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/gtk3-nocsd-$1\.tar\.gz/ \
  https://github.com/ZaWertun/gtk3-nocsd/releases .*/v?(\d\S*)\.tar\.gz
